namespace Eco.Mods.TechTree
{
    using System;
    using System.Collections.Generic;
    using System.ComponentModel;
    using Eco.Gameplay.Blocks;
    using Eco.Gameplay.Components;
    using Eco.Gameplay.Components.Auth;
    using Eco.Gameplay.DynamicValues;
    using Eco.Gameplay.Economy;
    using Eco.Gameplay.Housing;
    using Eco.Gameplay.Interactions;
    using Eco.Gameplay.Items;
    using Eco.Gameplay.Minimap;
    using Eco.Gameplay.Objects;
    using Eco.Gameplay.Players;
    using Eco.Gameplay.Property;
    using Eco.Gameplay.Skills;
    using Eco.Gameplay.Systems.TextLinks;
    using Eco.Gameplay.Pipes.LiquidComponents;
    using Eco.Gameplay.Pipes.Gases;
    using Eco.Gameplay.Systems.Tooltip;
    using Eco.Shared;
    using Eco.Shared.Math;
    using Eco.Shared.Localization;
    using Eco.Shared.Serialization;
    using Eco.Shared.Utils;
    using Eco.Shared.View;
    using Eco.Shared.Items;
    using Eco.Gameplay.Pipes;
    using Eco.World.Blocks;
    
    [Serialized]    
    [RequireComponent(typeof(PropertyAuthComponent))]
    [RequireComponent(typeof(SolidGroundComponent))]
    [RequireComponent(typeof(HousingComponent))]

    public partial class OutdoorTableObject : WorldObject
    {

        static OutdoorTableObject()
        {

        WorldObject.AddOccupancy<OutdoorTableObject>(new List<BlockOccupancy>()
                {

                new BlockOccupancy(new Vector3i(0, 0, 0), typeof(SolidWorldObjectBlock)),
                new BlockOccupancy(new Vector3i(0, 1, 0), typeof(SolidWorldObjectBlock)),
                }); 
        }
        public override string FriendlyName { get { return "Outdoor Table"; } } 


        protected override void Initialize()
        {
            this.GetComponent<HousingComponent>().Set(OutdoorTableItem.HousingVal);                                


        }

        public override void Destroy()
        {
            base.Destroy();
        }
       
    }

    [Serialized]
    public partial class OutdoorTableItem :
        WorldObjectItem<OutdoorTableObject> 
    {
        public override string FriendlyName { get { return "Outdoor Table"; } } 
        public override string Description  { get { return  ""; } }

        static OutdoorTableItem()
        {

        }

        [TooltipChildren] public HousingValue HousingTooltip { get { return HousingVal; } }
        [TooltipChildren] public static HousingValue HousingVal { get { return new HousingValue() 
                                                {
                                                    Category = "General",
                                                    Val = 2,                                   
                                                    TypeForRoomLimit = "Table", 
                                                    DiminishingReturnPercent = 0.6f    
        };}}
    }


    [RequiresSkill(typeof(WoodworkingSkill), 4)]
    public partial class OutdoorTableRecipe : Recipe
    {
        public OutdoorTableRecipe()
        {
            this.Products = new CraftingElement[]
            {
                new CraftingElement<OutdoorTableItem>(),
            };

            this.Ingredients = new CraftingElement[]
            {
                
                new CraftingElement<LumberItem>(typeof(WoodworkingEfficiencySkill), 30, WoodworkingEfficiencySkill.MultiplicativeStrategy),
                new CraftingElement<LogItem>(4),
                new CraftingElement<UmbrellaItem>(1),   
            };
            SkillModifiedValue value = new SkillModifiedValue(30, WoodworkingSpeedSkill.MultiplicativeStrategy, typeof(WoodworkingSpeedSkill), Localizer.Do("craft time"));
            SkillModifiedValueManager.AddBenefitForObject(typeof(OutdoorTableRecipe), Item.Get<OutdoorTableItem>().UILink(), value);
            SkillModifiedValueManager.AddSkillBenefit(Item.Get<OutdoorTableItem>().UILink(), value);
            this.CraftMinutes = value;
            this.Initialize("Table Exterieur", typeof(RoundTableRecipe));
            CraftingComponent.AddRecipe(typeof(CarpentryTableObject), this);
        }
    }
}